<?php
/*
 * Author: Michael Finkenberger
 * @since V1.1.0.0
 * Last change in plugin version: V1.5.6
 * Date: 07.04.2022
 * Tested with plugin version: V1.8.2.0
*/

if(!defined('ABSPATH')) die(); // no direct access

function foodle_meta_fields($user) {
  global $foodle_title;
  if ( ( get_option('foodle_meta_fields') ) && ( count((array)get_option('foodle_meta_fields')) != 0 ) ) {
    ?>
    <p>&nbsp;</p>
    <div class="foodle-user-meta" style="background-color:#f8f8f8; border: dotted 1px #cccccc; margin:0px; padding:0px 0px 0px 6px;">
    <h2><?php echo $foodle_title;?></h2>
    <table class="form-table">
    <?php
      $foodle_main = ''; // just to be sure...
      $foodle_main_meta = ''; // just to be sure...
      $foodle_fieldindex = -1; // Initialize to -1 so that the first loop will see 0 as the first index
      foreach ( get_option('foodle_meta_fields') as $foodle_fieldname => $foodle_fielddescription ) {
        $foodle_fieldindex += 1; // just index the fields (0 = main-category, 1-... = sub-categories)
        if ( $foodle_fieldindex == 0 ) {
          $foodle_main = $foodle_fieldname; // remember main category...
          $foodle_main_meta = foodle_fieldname_to_meta_name($foodle_fieldname); // ... and its usermeta representation
        }
        $foodle_meta = foodle_fieldname_to_meta_name($foodle_fieldname);
        ?>
        <tr>
          <th><label for="<?php echo $foodle_fieldname; ?>"><?php echo str_replace('••', '', str_replace(' ', '&nbsp;', $foodle_fieldname));?></th>
          <td>
            <input type="hidden" name="meta_name[]" value="<?php echo $foodle_meta ?>"/>
            <?php $foodle_select = ( ( get_option('foodle_meta_defaults_sorting') ) && ( isset(get_option('foodle_meta_defaults_sorting')[$foodle_fieldname]['sortlist']) ) && ( get_option('foodle_meta_defaults_sorting')[$foodle_fieldname]['sorttype'] == 'drop-down' ) && ( get_option('foodle_meta_defaults_sorting')[$foodle_fieldname]['sortlist'] != '' ) );
                  if ( $foodle_select )
                    echo '<select';
                  else
                    echo '<input type="text" size="38"';
                  $foodle_disabled = '';
                  $get_user_meta_user_id_foodle_meta_true = ( is_string($user) ) ? '' : get_user_meta($user->ID, $foodle_meta, true);

                  // check, if there's any array somewhere in the subject user meta data
                  $foodle_users = get_users(array(
                    'orderby'  => 'meta_value',
                    'meta_key' => 'last_name', // just a habit ;-)
                    'order'    => 'ASC'
                  ));
                  $foodle_array_found = false;
                  foreach ( $foodle_users as $foodle_user ) {
                    if ( is_array(get_user_meta($foodle_user->ID, $foodle_meta, true)) ) {
                      $foodle_array_found = true;
                      break;
                    }
                  }

                  if ( $foodle_array_found ) {
                    $foodle_disabled = 'disabled';
                    $get_user_meta_user_id_foodle_meta_true = __('Disabled (\'Array\' found)','foodle-for-democracy-poll');
                  }
            ?>

              <?php if ( ( ! $foodle_select ) && ( isset(get_option('foodle_regex_main')[str_replace('••', '', $foodle_fieldname)]) ) && ( $foodle_fieldindex != 0 ) ): // remove the '••' in case the field shall use an existing reference ?>
                id="<?php echo '⇒⇒'.str_replace('••', '', str_replace('.','€', str_replace(' ','_', $foodle_fieldname))) // remove the '••' in case the field shall use an existing reference ?>"
                value="<?php echo esc_attr($get_user_meta_user_id_foodle_meta_true); // Doubled 'value' for later extended use ?>"
                readonly
              <?php else: ?>
                id="<?php echo str_replace('••', '', str_replace('.','€', str_replace(' ', '_', $foodle_fieldname))) ?>"
                value="<?php echo esc_attr($get_user_meta_user_id_foodle_meta_true); ?>"
              <?php endif ?>

              <?php
                if ( ( $foodle_fieldindex == 0 ) && ( get_option('foodle_regex_main') ) ) {
                  /* Modify automatically according RegExp settings */
                  if ( $foodle_select )
                    $output = 'onchange="var $=jQuery; ';
                  else
                    $output = 'onkeyup="var $=jQuery; ';
                  foreach( get_option('foodle_regex_main') as $foodle_targetfield => $foodle_regex_definition) {
                    $output .=  "$('#⇒⇒".str_replace('.','€',str_replace(' ','_', $foodle_targetfield))."').attr('value',$(this).val().replace(".$foodle_regex_definition[0].",'".$foodle_regex_definition[1]."'));";
                  }
                  $output .= '" autocomplete="off"';
                  echo $output;
                }
              ?>

              name="<?php echo $foodle_meta ?>"
              <?php echo ' '.$foodle_disabled; ?>
            />

            <?php if ( $foodle_select ) {
              foreach( explode('<br>', get_option('foodle_meta_defaults_sorting')[$foodle_fieldname]['sortlist']) as $foodle_option ) {
                if ( esc_attr(get_user_meta($user->ID, $foodle_meta, true)) == $foodle_option )
                  $foodle_selected = 'selected="selected"';
                else
                  $foodle_selected = '';
                echo '<option value="'.$foodle_option.'" '.$foodle_selected.'>'.$foodle_option.'</option>';
              }
              echo '</select>';
            } ?>
            
            </label>
            <?php if ( ( ! $foodle_select ) && ( isset(get_option('foodle_regex_main')[str_replace('••', '', array_keys(get_option('foodle_meta_fields'))[$foodle_fieldindex])]) ) && ( get_option('foodle_regex_main')[str_replace('••', '', array_keys(get_option('foodle_meta_fields'))[$foodle_fieldindex])] != '' ) ): // remove the '••' in case the field shall use an existing reference
              if ( $foodle_fielddescription[0] != '' ) $foodle_fielddescription[0] = '<br>'.$foodle_fielddescription[0]; ?>
              <span class="description"><?php echo $foodle_fielddescription[0].'<br>'.sprintf(__('Will be filled automatically based on the field \'%s\'','foodle-for-democracy-poll'), str_replace('••', '', $foodle_main)) ?></span>
            <?php else: ?>
              <span class="description"><?php echo '<br>'.$foodle_fielddescription[0] ?></span>
            <?php endif ?>
          </td>
        </tr>
        <?php
      }
      ?>
      </table>
      </div>
      <p>&nbsp;</p>
    <?php
    echo '<script type="text/javascript"> var $=jQuery; ';
    foreach ( get_option('foodle_meta_fields') as $foodle_fieldname => $foodle_fielddescription ) {
      if ( ( strpos($foodle_fieldname, '••') === 0 ) && ( $foodle_fielddescription[1] != '' ) ) { // avoid to refer to an existing input field with no link to its user meta representation
        echo '$("#'.$foodle_fielddescription[1].'").attr("disabled", "disabled");';
        echo '$("#'.$foodle_fielddescription[1].'").after("<br>'.sprintf(__('Please use the related \'%s\' field in the %s area for your input','foodle-for-democracy-poll'), str_replace('••', '', $foodle_fieldname), $foodle_title).'!");';
      }
    }
    echo '</script>';
  } else if ( in_array('administrator', (array)$user->roles) ) {
    ?>
      <p>&nbsp;</p>
      <div class="foodle-user-meta" style="background-color:#f8f8f8; border: dotted 1px #cccccc; margin:0px; padding:0px 0px 0px 6px;">
        <h2><?php echo $foodle_title;?></h2>
        <p><?php echo $foodle_title.' '.__('profile fields are not defined (yet)','foodle-for-democracy-poll').'.'; ?></p>
      </div>
      <p>&nbsp;</p>
    <?php
  }
}
add_action('show_user_profile', 'foodle_meta_fields', 999); // editing your own profile
add_action('edit_user_profile', 'foodle_meta_fields', 999); // editing another user
add_action('user_new_form', 'foodle_meta_fields', 999); // creating a new user



function foodle_meta_fields_save($userId) {
  if (!current_user_can('edit_user', $userId)) {
    return;
  }
  if ( ! isset($_REQUEST['meta_name']) ) {
    return;
  }

  foreach ( $_REQUEST['meta_name'] as $foodle_meta_fieldname ) {
    if ( isset($_REQUEST[$foodle_meta_fieldname]) )
      update_user_meta($userId, sanitize_text_field($foodle_meta_fieldname), sanitize_text_field($_REQUEST[$foodle_meta_fieldname]));
  }
}
add_action('personal_options_update', 'foodle_meta_fields_save'); // updating your own profile
add_action('edit_user_profile_update', 'foodle_meta_fields_save'); // updating another user
add_action('user_register', 'foodle_meta_fields_save'); // registering a new user



function foodle_fieldname_to_meta_name($foodle_fieldname) {
  if ( strpos($foodle_fieldname, '••') === 0 ) return str_replace('••','',$foodle_fieldname);

  return 'foodle-field-'.str_replace('.','€',str_replace(' ','_',strtolower($foodle_fieldname)));
}
// The format of the meta field name is: foodle-field- lower_case_fieldname_without_spaces_or_periods (= fieldslug)


